<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
	<modelVersion>4.0.0</modelVersion>

	<groupId>kr.co.swh</groupId>
	<artifactId>lecture-opensource</artifactId>
	<version>1.0</version>
	<packaging>jar</packaging>

	<name>opensource</name>
	<url>http://maven.apache.org</url>

	<properties>
		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
		
		<!-- 1일차 -->
		<junit.version>3.8.1</junit.version>
		<mockito.version>1.10.19</mockito.version>
		
		<!-- 2일차 -->
		<mysql.version>5.1.36</mysql.version>
		<hibernate.version>5.2.12.Final</hibernate.version>
		
		<!-- 3일차 -->
		<lombok.version>1.16.20</lombok.version>
		<jsoup.version>1.11.2</jsoup.version>
		<jackson.version>2.9.4</jackson.version>
		<gson.version>2.8.2</gson.version>
		<dom4j.version>2.1.0</dom4j.version>
		<ini4j.version>0.5.4</ini4j.version>
		
		<!-- 4일차 -->
		<log4j2.version>2.10.0</log4j2.version>
		<guava.version>23.6-jre</guava.version>
		<quartz.version>2.2.1</quartz.version>

		<jetty.version>9.4.8.v20171121</jetty.version>
		<jersey.version>1.19.4</jersey.version>
		
	</properties>

	<!-- lombok -->
	<repositories>
		<repository>
			<id>projectlombok.org</id>
			<url>http://projectlombok.org/mavenrepo</url>
		</repository>
		
		<repository>
		    <id>jcenter</id>
		    <name>jcenter-bintray</name>
		    <url>https://jcenter.bintray.com</url>
		</repository>
	</repositories>


	<dependencies>
		<dependency>
			<groupId>junit</groupId>
			<artifactId>junit</artifactId>
			<version>3.8.1</version>
			<scope>test</scope>
		</dependency>

		<dependency>
			<groupId>org.mockito</groupId>
			<artifactId>mockito-all</artifactId>
			<version>1.10.19</version>
			<scope>test</scope>
		</dependency>


		<!-- MariaDB / Mysql -->
		<dependency>
			<groupId>mysql</groupId>
			<artifactId>mysql-connector-java</artifactId>
			<version>${mysql.version}</version>
		</dependency>

		<!-- 하이버네이트 -->
		<dependency>
			<groupId>org.hibernate</groupId>
			<artifactId>hibernate-core</artifactId>
			<version>${hibernate.version}</version>
		</dependency>


		<!-- 어노테이션 기반 자동 바이너리 생성 -->
		<dependency>
			<groupId>org.projectlombok</groupId>
			<artifactId>lombok</artifactId>
			<version>${lombok.version}</version>
		</dependency>

		<!-- HTTP 웹 브라우저 파싱 -->
		<dependency>
			<groupId>org.jsoup</groupId>
			<artifactId>jsoup</artifactId>
			<version>${jsoup.version}</version>
		</dependency>
		

		<!-- 파일 포맷 JSON -->
		<dependency>
			<groupId>com.fasterxml.jackson.core</groupId>
			<artifactId>jackson-databind</artifactId>
			<version>${jackson.version}</version>
		</dependency>
		<!-- 파일 포맷 XML -->
		<dependency>
			<groupId>com.fasterxml.jackson.dataformat</groupId>
			<artifactId>jackson-dataformat-xml</artifactId>
			<version>${jackson.version}</version>
		</dependency>
		<!-- 파일 포맷 JSON -->
		<dependency>
			<groupId>com.google.code.gson</groupId>
			<artifactId>gson</artifactId>
			<version>${gson.version}</version>
		</dependency>

		<!-- 파일 포맷 DOM4J -->
		<dependency>
			<groupId>org.dom4j</groupId>
			<artifactId>dom4j</artifactId>
			<version>${dom4j.version}</version>
			<!-- 하이버네이트 에 이전 버전이 있으므로 exclusion을 사용 -->
		</dependency>

		<!-- 파일 포맷 INI4J -->
		<dependency>
			<groupId>org.ini4j</groupId>
			<artifactId>ini4j</artifactId>
			<version>${ini4j.version}</version>
		</dependency>


		<!-- Log4J 로그 -->
		<dependency>
			<groupId>org.apache.logging.log4j</groupId>
			<artifactId>log4j-core</artifactId>
			<version>${log4j2.version}</version>
		</dependency>
		
		<!-- Lists를 주로 사용 -->
		<dependency>
			<groupId>com.google.guava</groupId>
			<artifactId>guava</artifactId>
			<version>${guava.version}</version>
		</dependency>
		
		<!-- 스케줄링 -->
		<dependency>
			<groupId>org.quartz-scheduler</groupId>
			<artifactId>quartz</artifactId>
			<version>${quartz.version}</version>
		</dependency>
		
		
		<!-- SERVER SIDE -->
		<!-- HTTP 서버 -->
		<dependency>
			<groupId>org.eclipse.jetty</groupId>
			<artifactId>jetty-server</artifactId>
			<version>${jetty.version}</version>
		</dependency>
		<!-- HTTP 웹 서버 -->
		<dependency>
			<groupId>org.eclipse.jetty</groupId>
			<artifactId>jetty-webapp</artifactId>
			<version>${jetty.version}</version>
		</dependency>
		<!-- HTTP 웹소켓 -->
		<dependency>
			<groupId>org.eclipse.jetty.websocket</groupId>
			<artifactId>websocket-server</artifactId>
			<version>${jetty.version}</version>
		</dependency>
		<!-- [ERROR] No JSP support.  Check that JSP jars are in lib/jsp and that the JSP option has been specified to start.jar -->
		<dependency>
    		<groupId>org.eclipse.jetty</groupId>
    		<artifactId>jetty-jsp</artifactId>
    		<version>9.2.24.v20180105</version>
		</dependency>

		<!-- REST 웹서비스 -->
		<dependency>
			<groupId>com.sun.jersey</groupId>
			<artifactId>jersey-server</artifactId>
			<version>${jersey.version}</version>
		</dependency>
		<dependency>
			<groupId>com.sun.jersey</groupId>
			<artifactId>jersey-bundle</artifactId>
			<version>${jersey.version}</version>
		</dependency>
		<dependency>
			<groupId>com.sun.jersey</groupId>
			<artifactId>jersey-json</artifactId>
			<version>${jersey.version}</version>
		</dependency>
		 
		<!-- CLIENT SIDE -->
		
		<!-- https://mvnrepository.com/artifact/org.apache.commons/commons-lang3 -->
		<dependency>
		    <groupId>org.apache.commons</groupId>
		    <artifactId>commons-lang3</artifactId>
		    <version>3.9</version>
		</dependency>
		<dependency>
			<groupId>org.scala-lang</groupId>
			<artifactId>scala-library</artifactId>
			<!-- <version>2.12.7</version> -->
			<version>2.11.8</version>
		</dependency>
		
		<dependency>
		    <groupId>com.ibm.icu</groupId>
			<artifactId>icu4j</artifactId>
			<version>63.1</version>
		</dependency>

		<dependency>
			<groupId>org.scala-lang</groupId>
			<artifactId>scala-library</artifactId>
			<!-- <version>2.12.7</version> -->
			<version>2.11.8</version>
		</dependency>
	    <dependency>
	        <groupId>org.bitbucket.eunjeon</groupId>
			<artifactId>seunjeon_2.11</artifactId>
	        <version>1.2.0</version>
	    </dependency>
	    <!-- <dependency>
		    <groupId>com.jsuereth</groupId>
		    <artifactId>sbt-pgp</artifactId>
		    <version>1.1.0</version>
		</dependency> -->
		
		<dependency>
		    <groupId>net.dv8tion</groupId>
		    <artifactId>JDA</artifactId>
		    <version>LATEST</version>
		</dependency>
		<!-- https://mvnrepository.com/artifact/org.apache.httpcomponents/httpclient -->
		<dependency>
			<groupId>org.apache.httpcomponents</groupId>
			<artifactId>httpclient</artifactId>
			<version>4.5.10</version>
		</dependency>
	    
		<dependency>
			<groupId>com.sparkjava</groupId>
			<artifactId>spark-core</artifactId>
			<version>2.9.0</version>
		</dependency>
		<!-- https://mvnrepository.com/artifact/org.freemarker/freemarker -->
		<dependency>
			<groupId>org.freemarker</groupId>
			<artifactId>freemarker</artifactId>
			<version>2.3.29</version>
		</dependency>
				
		
		<!-- https://mvnrepository.com/artifact/org.twitter4j/twitter4j-core -->
		<dependency>
		    <groupId>org.twitter4j</groupId>
		    <artifactId>twitter4j-core</artifactId>
		    <version>4.0.7</version>
		</dependency>
		
		<!-- https://mvnrepository.com/artifact/org.twitter4j/twitter4j-stream -->
		<dependency>
		    <groupId>org.twitter4j</groupId>
		    <artifactId>twitter4j-stream</artifactId>
		    <version>4.0.7</version>
		</dependency>
		
		
		<!-- https://mvnrepository.com/artifact/com.rabbitmq/amqp-client -->
		<dependency>
		    <groupId>com.rabbitmq</groupId>
		    <artifactId>amqp-client</artifactId>
		    <version>5.7.3</version>
		</dependency>

		<dependency>
			<groupId>org.elasticsearch</groupId>
			<artifactId>elasticsearch</artifactId>
			<version>1.7.6</version>
		</dependency>
		
		<!-- spark section -->
		<dependency>
			<groupId>org.apache.spark</groupId>
			<artifactId>spark-core_2.12</artifactId>
			<version>2.4.0</version>
		</dependency>
		<dependency>
			<groupId>org.apache.spark</groupId>
			<artifactId>spark-mllib_2.12</artifactId>
			<version>2.4.0</version>
		</dependency>
		
		<!-- Exception in thread "main" java.lang.ArrayIndexOutOfBoundsException: 10582 -->
		<dependency>
			<groupId>com.thoughtworks.paranamer</groupId>
			<artifactId>paranamer</artifactId>
			<version>2.8</version>
		</dependency>
	
	</dependencies>
	
	<build>
    <plugins>
      <plugin>
        <artifactId>maven-compiler-plugin</artifactId>
        <version>3.5.1</version>
        <configuration>
          <source>1.8</source>
          <target>1.8</target>
        </configuration>
      </plugin>
    </plugins>
  </build>
</project>
